	
	@Echo On
	SetLocal EnableDelayedExpansion

	Set CUR_YYYY=%Date:~10,4%
	Set CUR_MM=%Date:~4,2%
	Set CUR_DD=%Date:~7,2%
		
	Set CUR_HH=%Time:~0,2%
	If %CUR_HH% LSS 10 ( Set "CUR_HH=0%Time:~1,1%" )
	
	Set CUR_NN=%Time:~3,2%
	Set CUR_SS=%Time:~6,2%
	Set CUR_MS=%Time:~9,2%

	Set _Ts=
	Set _Ts=!_Ts!%CUR_YYYY%-
	Set _Ts=!_Ts!%CUR_MM%%CUR_DD%-
	Set _Ts=!_Ts!%CUR_HH%%CUR_NN%-
	Set _Ts=!_Ts!%CUR_SS%%CUR_MS%
		
	For /F "UseBackQ Delims=" %%S In ( ".\Settings.csv" ) Do (
		Call Set %%S
	)
	
	:_Support_Absolute AliKit
	
	Call :_Support_Erase
	
	> "!_Builder!" Type NUL
	Echo ^> "!_Log!" Type NUL >> "!_Builder!" 
	Echo Echo "^^!_Compiler^^!" ^^!_Compiler_Options^^! ^>^> "^^!_Log^^!" >> "!_Builder!"
	
	Call :_Support_Exists Log
	Call :_Support_Placed Log
	Call :_Support_Exists Compiler
	Call :_Support_Exists Debugger
	
	Call "!_Support!" Utility Debugger
	Call "!_Support!" Exists Log
	Call "!_Support!" Placed Log
	Call "!_Support!" Exists Compiler
	Call "!_Support!" Exists Debugger
	
	Echo "!_Compiler!" !_Compiler_Options! ^>^> "!_Log!" >> "!_Builder!"
	
	Echo Set /A "Line_Count=!Line_Count!" >> "!_Builder!"
	
	Echo For /F "UseBackQ Skip=!Line_Skip! Delims=" %%%%G in ^( `"!_Compiler!" !_Compiler_Options!` ^)
	
		Echo Set /A "Line_Count+=1" >> "!_Builder!"
			
		@Echo.
			
		Echo %%%%G ^>^> "!_Log!" >> "!_Builder!"
			
	Echo ^) >> "!_Builder!"
	
	Echo If ^^!Line_Count^^! EQU 0 ^( >> "!_Builder!"
	
		Echo Echo !_Chirp_Validate! ^>^> "!_Log!" >> "!_Builder!"
	
	Echo ^) Else ^( >> "!_Builder!"

		Echo Echo !_Chirp_Notify! ^>^> "!_Log!" >> "!_Builder!"
	
	Echo ^) >> "!_Builder!"
	
	Echo Exit /B >> "!_Builder!"
	
	Exit /B

:_Support_Exists

@Echo.  >> "!_Support!"
@Echo Rem :: === %~0_%~1 === >> "!_Support!"
@Echo.  >> "!_Support!"

Echo %~0_%~1 >> "!_Support!"
	
	Echo If Not Exist "^^!_%%~1^^!" ^( >> "!_Support!"
		Echo Echo ^^!_Chirp_%%~1_Missing^^! ^>^> "!_Log!" >> "!_Support!"
	Echo ^) Else ^( >> "!_Support!"
		Echo Echo ^^!_Chirp_%%~1_Found^^! ^>^> "!_Log!" >> "!_Support!"
	Echo ^) >> "!_Support!"
	
	Echo Exit /B >> "!_Support!"
	
	Exit /B

:_Support_Placed

@Echo.  >> "!_Support!"
@Echo Rem :: === %~0_%~1 === >> "!_Support!"
@Echo.  >> "!_Support!"

If Not Exist "!_StarterPack!" (
	MkDir "!_StarterPack!"
)

Echo %~0_%~1 >> "!_Support!"
	
	Echo If Exist ^^!_%%~1^^! ^( >> "!_Support!"
	
		Echo Echo !_Chirp_BegQuot! !_Chirp_Success! ^^!_Chirp_%%~1_Placed^^! !_Chirp_EndQuot! ^>^> "!_Log!" >> "!_Support!"
	
	Echo ^) >> "!_Support!"

	Echo Exit /B >> "!_Support!"
	
	Exit /B

:_Support_Erase

	> "!_Support!" Type NUL

	Echo If "%%~1"=="" ^( Exit /B ^) >> "!_Support!"
	Echo If "%%~2"=="" ^( Exit /B ^) >> "!_Support!"
	
	Echo Call :__Support_%%~1 %%~2  >> "!_Support!"
	
	Echo Exit /B >> "!_Support!"
	
	Exit /B
	
:_Support_Utility

@Echo.  >> "!_Support!"
@Echo Rem :: === %~0_%~1 === >> "!_Support!"
@Echo.  >> "!_Support!"

Echo %~0_%~1 >> "!_Support!"
	
	Echo ^> ".\!_Project! Debugger.cmd" Type NUL >> "!_Support!"
	
	Echo Echo "!_Debugger!" ".\!_Project!.exe" ^>^> "!_StarterPack!!_Project! Debugger.cmd" >> "!_Support!"
	
	Echo Exit /B >> "!_Support!"
	
	Exit /B
